<script>
import {
  GlSearchBoxByType,
  GlLink,
  GlSafeHtmlDirective as SafeHtml,
  GlTooltipDirective as GlTooltip,
} from "@gitlab/ui";
import { debounce } from "lodash";
import { directive as clickOutside } from "v-click-outside";
import { fetchResults } from "../../services/elastic_api";
import { docsBaseURL } from "../../utils/environment";
import { trackSearchResultClick } from "../../search/utils";
import SuggestedItems from "./suggested_items.vue";

export default {
  components: {
    GlSearchBoxByType,
    GlLink,
    SuggestedItems,
  },
  directives: {
    clickOutside,
    SafeHtml,
    GlTooltip,
  },
  props: {
    numResults: {
      type: Number,
      required: true,
    },
  },
  data() {
    return {
      activeLink: -1,
      historyItems: 0,
      isLoading: false,
      moreResultsPath: "",
      results: [],
      showTooltip: true,
      searchQuery: "",
      showModal: false,
      showResultPanel: false,
      submitted: false,
    };
  },
  computed: {
    hasMoreResults() {
      return this.results.length >= this.numResults;
    },
    hasNoResults() {
      return !this.results.length && this.submitted && this.searchQuery;
    },
    showSuggested() {
      return !this.searchQuery;
    },
  },
  watch: {
    searchQuery() {
      this.results = [];
      this.showResultPanel = false;
      this.showTooltip = this.searchQuery.length === 0;
      this.submitted = false;
      this.moreResultsPath = `${docsBaseURL()}search/?q=${encodeURI(this.searchQuery)}`;
      this.debouncedGetResults();
    },
  },
  created() {
    this.debouncedGetResults = debounce(this.getResults, 500);
  },
  methods: {
    async getResults() {
      this.showResultPanel = false;
      this.isLoading = true;

      const pageInfo = {
        pageNumber: 1,
        numResults: this.numResults,
      };

      const response = await fetchResults(this.searchQuery, [], pageInfo);
      this.isLoading = false;
      this.results = response?.results || [];

      this.submitted = true;
      this.showResultPanel = true;
    },
    showAllResults() {
      // Sends the user to the advanced search page if they hit Enter.
      if (this.searchQuery) {
        window.location.href = this.moreResultsPath;
      }
    },
    keyboardNav(e) {
      const isArrowUp = e.key === "ArrowUp";
      const isArrowDown = e.key === "ArrowDown";
      const searchBox = document.querySelector("input[type=search]");

      if (isArrowUp || isArrowDown) {
        const activeIndex = this.activeLink + (isArrowUp ? -1 : 1);

        // If we're at the top or bottom of the list, go back to the search box.
        const listLength = this.searchQuery
          ? this.results.length
          : this.historyItems - 1;
        if (activeIndex < 0 || activeIndex > listLength) {
          this.activeLink = -1;
          searchBox.focus();
          // Reset the value after focus so that the cursor is at the end of the text.
          searchBox.value = this.searchQuery;
          return;
        }
        // Otherwise, select the previous or next link.
        this.setActiveResult(
          document.querySelector(`[data-link-index="${activeIndex}"]`),
        );
      }
    },
    setActiveResult(result) {
      if (result) {
        result.focus();
        this.activeLink = Number(result.dataset.linkIndex);
      }
    },
    deactivate() {
      this.showResultPanel = false;
      this.showModal = false;
      this.activeLink = -1;
      this.showTooltip = this.searchQuery.length === 0;
    },
    trackSearchResultClick,
  },
};
</script>

<template>
  <div>
    <div
      v-click-outside="() => deactivate()"
      class="gs-wrapper gl-text-base gl-my-3 md:gl-mt-0 md:gl-mb-0"
      @keydown.arrow-down.prevent="keyboardNav"
      @keydown.arrow-up.prevent="keyboardNav"
      @keydown.escape="deactivate()"
      @keydown.tab="deactivate()"
    >
      <form class="gl-relative">
        <gl-search-box-by-type
          v-model="searchQuery"
          :is-loading="isLoading"
          :borderless="true"
          placeholder="Search GitLab documentation"
          autocomplete="off"
          aria-label="Search"
          @focus="
            showResultPanel = true;
            showModal = true;
          "
          @keydown.enter.prevent="showAllResults()"
        />
        <kbd
          v-show="showTooltip && !isLoading"
          v-gl-tooltip.bottom.hover.html
          class="gl-absolute gl-z-1 gl-bg-gray-100 gl-text-gray-700"
          title="Use the shortcut keys<br><kbd>/</kbd> or <kbd>s</kbd> to start a search"
          >/</kbd
        >
      </form>
      <div
        v-if="showResultPanel"
        class="gs-results gl-absolute gl-z-4 gl-bg-white gl-px-4 gl-shadow"
      >
        <ul
          v-if="results.length"
          data-testid="search-results"
          class="gl-pl-0 gl-mb-0 gl-py-3"
        >
          <li
            v-for="(result, index) in results"
            :key="result.id"
            class="gl-list-none"
          >
            <gl-link
              data-result-type="dropdown"
              :data-search-query="searchQuery"
              :data-link-index="index"
              class="gl-text-gray-700 gl-py-3 gl-px-2 gl-block gl-text-left"
              :href="result.url_path"
              @click="(e) => trackSearchResultClick(e, result, searchQuery, 1)"
            >
              <span v-safe-html="result.title" class="gl-block"></span>
              <span
                v-if="result.breadcrumbs"
                v-safe-html="result.breadcrumbs"
                class="gl-text-xs gl-block gl-text-gray-400"
              ></span>
            </gl-link>
          </li>
          <li v-if="hasMoreResults" class="gl-list-none gl-mb-1">
            <gl-link
              :data-link-index="results.length"
              data-testid="more-results"
              :href="moreResultsPath"
              class="gl-text-gray-700 gl-pt-3 gl-pb-3 gl-px-2 gl-block gl-text-left"
            >
              See all results
            </gl-link>
          </li>
        </ul>
        <p
          v-if="hasNoResults"
          data-testid="no-results"
          class="gl-text-left gl-pt-3 gl-my-2 gl-pb-2"
        >
          No results found.
        </p>
        <suggested-items
          v-if="showSuggested"
          @pageHistoryInit="(items) => (historyItems = items)"
        />
      </div>
    </div>
    <transition name="fade">
      <div
        v-if="showModal"
        class="gl-hidden lg:gl-block gl-z-3 modal-backdrop"
      ></div>
    </transition>
  </div>
</template>
